SystemOrganization addCategory: #'PBE-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell commentStamp: 'ChristianGoetz 5/13/2012 19:55' prior: 0!
A LOCell is something really cool. It is a part of a game!!

Instance Variables
	mouseAction:		<Object>

mouseAction
	- xxxxx
!

!LOCell methodsFor: 'initialization' stamp: 'ChristianGoetz 5/13/2012 21:43'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff! !

!LOCell methodsFor: 'accessing' stamp: 'ChristianGoetz 5/14/2012 21:22'!
mouseAction: aBlock
	^ mouseAction := aBlock ! !

!LOCell methodsFor: 'accessing' stamp: 'ChristianGoetz 5/14/2012 21:34'!
mouseUp: anEvent
	mouseAction value ! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame methodsFor: 'initialization' stamp: 'ChristianGoetz 5/14/2012 19:07'!
cellsPerSide 
	"The number of cells along each side of the game"
	^ 10! !

!LOGame methodsFor: 'initialization' stamp: 'ChristianGoetz 5/14/2012 18:50'!
initialize 
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := LOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width * n)@(height * n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [:i :j | self newCellAt: i at: j].! !

!LOGame methodsFor: 'as yet unclassified' stamp: 'ChristianGoetz 5/14/2012 22:09'!
mouseMove: anEvent! !

!LOGame methodsFor: 'initialization' stamp: 'ChristianGoetz 5/14/2012 22:03'!
newCellAt: i at: j
	"Create a cell for position (i,j) and add it to my on-screen representation at the appropriate screen position. Answer the new cell"
	| c origin |
	c := LOCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^ c! !

!LOGame methodsFor: 'game logic' stamp: 'ChristianGoetz 5/14/2012 21:18'!
toggleNeighboursOfCellAt: i at: j
	(i > 1) ifTrue: [(cells at: i - 1 at: j) toggleState].
	(i < self cellsPerSide) ifTrue: [(cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [(cells at: i at: j - 1) toggleState].
	(j < self cellsPerSide) ifTrue: [(cells at: i at: j + 1) toggleState].! !
